package de.tub.mapc.Coordination;

import java.io.IOException;
import java.util.Collection;
import java.util.LinkedList;

import de.dailab.keks.io.IAddress;
import de.dailab.keks.io.IDeserialiser;
import de.dailab.keks.io.ISerialiser;
import de.jiac.micro.agent.memory.IFact;
import de.tub.mapc.Coordination.goals.AbstractGoal;
import de.tub.mapc.knowledge.Position;


public class Agent implements IFact, Voter, Comparable<Agent>{
	private Position position;
	private IAddress address;
	private AbstractGoal goal;
	private boolean goalWasUnreachable =false;
	private int pathlengthToAHerd; //only for assignGoals()!!!
	
	
	public Agent(){
		
	}
	
	public Agent(int x, int y, IAddress address){
		position = new Position(x,y);
//		posx = x;
//		posy = y;
		this.address = address;
	}
	
	public Agent(Position p, IAddress address){
		position = p;
		this.address = address;
	}
	/**
	 * only for assignGoals()!!!
	 * @param length
	 */
	public void setPathlengthToAHerd(int length){
		this.pathlengthToAHerd=length;
	}
	/**
	 * only for assignGoals()!!!
	 * @param length
	 */
	public int getPathlengthToAHerd(){
		return this.pathlengthToAHerd;
	}
	
	public Position getPosition(){
		return position;
	}
	
	public void setPosition(Position p){
		position = p;
	}
//	
//	public int getPosx() {
//		return posx;
//	}
//
//	public void setPosx(int posx) {
//		this.posx = posx;
//	}
//
//	public int getPosy() {
//		return posy;
//	}
//
//	public void setPosy(int posy) {
//		this.posy = posy;
//	}

	public IAddress getAddress() {
		return address;
	}

	/**
	 * ACHTUNG BITTE FUNKTION IN COORDINATION NUTZEN!!!!
	 * @param goal
	 */
	@Deprecated
	public void setGoal(AbstractGoal goal) {
		this.goal = goal;
		goalWasUnreachable = false;		
	}

	/**
	 * Return this agent's goal <br/>
	 * @return AbstractGoal, or <b>null !!</b>
	 */
	public AbstractGoal getGoal() {
		return goal;
	}
	
//	public void setPerception(GridField[] grid) {
//		this.perception = grid;
//	}
//
//	public GridField[] getPerception() {
//		return perception;
//	}
	
	public void setGoalWasUnreachable(boolean unreachable) {
		this.goalWasUnreachable = unreachable;
	}

	public boolean getGoalWasUnreachable() {
		return goalWasUnreachable;
	}

	@Override
	public void deserialise(IDeserialiser arg0) throws IOException,
			ClassNotFoundException {
//		posx = arg0.readInt();
//		posy = arg0.readInt();
		position = (Position) arg0.readObject();
		address = (IAddress)arg0.readObject();	
		goal = (AbstractGoal) arg0.readObject();
//		int size = arg0.readInt();
//		this.perception = new GridField[size];
//		for(int i = 0; i < perception.length; i++){
//			perception[i] = (GridField)arg0.readObject();
//		}
	}
	
	@Override
	public void serialise(ISerialiser arg0) throws IOException {
		arg0.writeObject(position);
//		arg0.writeInt(posx);
//		arg0.writeInt(posy);
		arg0.writeObject(address);
		arg0.writeObject(goal);
//		arg0.writeInt(perception.length);
//		for(int i = 0; i < perception.length; i++){
//			arg0.writeObject(perception[i]);
//		}		
	}

	@Override
	public int getPrio() {
		if(goal != null)return goal.getPriority();
		return 0;
	}

	@Override
	public Collection<Agent> getAgents() {
		Collection<Agent> l = new LinkedList<Agent>();
		l.add(this);
		return l;
	}
	

	@Override
	public int compareTo(Agent a) {
		if (this.pathlengthToAHerd < a.getPathlengthToAHerd())
			return -1;
		else if (this.pathlengthToAHerd > a.getPathlengthToAHerd())
			return 1;
		else
			return 0;
	}

	/**
	 * {@inheritDoc}
	 */
	@Override
	public int getValidSteps() {
		return 0;
	}

	
}